﻿using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using System.Collections.Generic;
using System.Web.Mvc;

namespace CreateWordSample.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }
        public ActionResult CreateDocument()
        {
            //Opens the Word template document
            using (WordDocument document = new WordDocument(ResolveApplicationDataPath("Template.docx")))
            {
                List<DataCollection> dataCollections = GetEmployees();
                //Creates an instance of “MailMergeDataTable” by specifying mail merge group name and “IEnumerable” collection.
                MailMergeDataTable dataTable = new MailMergeDataTable("DataCollection", dataCollections);
                //Performs Mail merge
                document.MailMerge.ExecuteNestedGroup(dataTable);
                //Saves the Word document to disk in DOCX format
                document.Save("Result.docx", FormatType.Docx, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);
            }
            return View();
        }
        public static List<DataCollection> GetEmployees()
        {
            List<property2> property213 = new List<property2>();
            property213.Add(new property2("1234"));
            List<Collection1> orders = new List<Collection1>();
            orders.Add(new Collection1("propertvalue", property213));
            List<Collection2> collect2 = new List<Collection2>();
            collect2.Add(new Collection2("prop3"));
            List<DataCollection> dataCollection = new List<DataCollection>();
            dataCollection.Add(new DataCollection(orders, collect2));
            return dataCollection;
        }

        public class DataCollection
        {
            public List<Collection1> Collection1 { get; set; }
            public List<Collection2> Collection2 { get; set; }
            public DataCollection(List<Collection1> customers1, List<Collection2> Collect2)
            {
                Collection1 = customers1;
                Collection2 = Collect2;
            }
        }
        public class property2
        {
            public string nestedproperty { get; set; }
            public property2(string nestedProp)
            {
                nestedproperty = nestedProp;
            }
        }

        public class Collection2
        {
            public string property3 { get; set; }
            public Collection2(string Property3)
            {
                property3 = Property3;
            }
        }
        public class Collection1
        {
            public string property { get; set; }
            public List<property2> property2 { get; set; }
            public Collection1(string Property, List<property2> propertynetsed)
            {
                property = Property;
                property2 = propertynetsed;
            }
        }
        //Get the path for Word template document
        protected string ResolveApplicationDataPath(string fileName)
        {
            //Data folder path is resolved from requested page physical path.
            string dataPath = new System.IO.DirectoryInfo(Request.PhysicalPath + "..\\..\\Data").FullName;
            return string.Format("{0}\\{1}", dataPath, fileName);
        }
        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}